# enopy

Python implementation of the eno library specification

## Installation

```
pip install enopy
```

## Getting started

Create an eno document, for instance `intro.eno`:

```eno
Greeting: Hello World!
```

A minimal example to read this file with `enopy`:

```python
>>> from enopy import parse
>>> with open('intro.eno', 'r') as file:
...   document = parse(file.read())
>>> document.field('Greeting')
'Hello World!'
```

## Complete documentation and API reference

See [eno-lang.org/python](https://eno-lang.org/python/)
