from ..errors import Validation as errors


class Empty:
  def __init__(self, context, instruction, parent):
    self.context = context
    self.instruction = instruction
    self.name = instruction['name']
    self.parent = parent
    self.touched = False

    instruction['element'] = self

  def __repr__(self):
    return f"<class Empty name=\"{self.name}\">"

  def error(self, message=None):
    if callable(message):
      message = message(self.name, None)

    return errors.value_error(self.context, message, self.instruction)

  def raw(self):
    return { self.name: None }

  def touch(self):
    self.touched = True

  def value(self):
    self.touched = True
    return None
