from ..error_types import ParseError


class Resolution:
  @staticmethod
  def copying_block_into_fieldset(context, instruction):
    message = context['messages']['resolution']['copying_block_into_fieldset'](
      instruction['line'] + context['indexing']
    )

    snippet = context['reporter'].report(context, instruction)

    selection = [
      [instruction['line'], 0],
      [instruction['line'], instruction['length']]
    ]

    return ParseError(message, snippet, selection)

  @staticmethod
  def copying_block_into_list(context, instruction):
    message = context['messages']['resolution']['copying_block_into_list'](
      instruction['line'] + context['indexing']
    )

    snippet = context['reporter'].report(context, instruction)

    selection = [
      [instruction['line'], 0],
      [instruction['line'], instruction['length']]
    ]

    return ParseError(message, snippet, selection)

  @staticmethod
  def copying_block_into_section(context, instruction):
    message = context['messages']['resolution']['copying_block_into_section'](
      instruction['line'] + context['indexing']
    )

    snippet = context['reporter'].report(context, instruction)

    selection = [
      [instruction['line'], 0],
      [instruction['line'], instruction['length']]
    ]

    return ParseError(message, snippet, selection)

  @staticmethod
  def copying_fieldset_into_field(context, instruction):
    message = context['messages']['resolution']['copying_fieldset_into_field'](
      instruction['line'] + context['indexing']
    )

    snippet = context['reporter'].report(context, instruction)

    selection = [
      [instruction['line'], 0],
      [instruction['line'], instruction['length']]
    ]

    return ParseError(message, snippet, selection)

  @staticmethod
  def copying_fieldset_into_list(context, instruction):
    message = context['messages']['resolution']['copying_fieldset_into_list'](
      instruction['line'] + context['indexing']
    )

    snippet = context['reporter'].report(context, instruction)

    selection = [
      [instruction['line'], 0],
      [instruction['line'], instruction['length']]
    ]

    return ParseError(message, snippet, selection)

  @staticmethod
  def copying_fieldset_into_section(context, instruction):
    message = context['messages']['resolution']['copying_fieldset_into_section'](
      instruction['line'] + context['indexing']
    )

    snippet = context['reporter'].report(context, instruction)

    selection = [
      [instruction['line'], 0],
      [instruction['line'], instruction['length']]
    ]

    return ParseError(message, snippet, selection)

  @staticmethod
  def copying_field_into_fieldset(context, instruction):
    message = context['messages']['resolution']['copying_field_into_fieldset'](
      instruction['line'] + context['indexing']
    )

    snippet = context['reporter'].report(context, instruction)

    selection = [
      [instruction['line'], 0],
      [instruction['line'], instruction['length']]
    ]

    return ParseError(message, snippet, selection)

  @staticmethod
  def copying_field_into_list(context, instruction):
    message = context['messages']['resolution']['copying_field_into_list'](
      instruction['line'] + context['indexing']
    )

    snippet = context['reporter'].report(context, instruction)

    selection = [
      [instruction['line'], 0],
      [instruction['line'], instruction['length']]
    ]

    return ParseError(message, snippet, selection)

  @staticmethod
  def copying_field_into_section(context, instruction):
    message = context['messages']['resolution']['copying_field_into_section'](
      instruction['line'] + context['indexing']
    )

    snippet = context['reporter'].report(context, instruction)

    selection = [
      [instruction['line'], 0],
      [instruction['line'], instruction['length']]
    ]

    return ParseError(message, snippet, selection)

  @staticmethod
  def copying_list_into_field(context, instruction):
    message = context['messages']['resolution']['copying_list_into_field'](
      instruction['line'] + context['indexing']
    )

    snippet = context['reporter'].report(context, instruction)

    selection = [
      [instruction['line'], 0],
      [instruction['line'], instruction['length']]
    ]

    return ParseError(message, snippet, selection)

  @staticmethod
  def copying_list_into_fieldset(context, instruction):
    message = context['messages']['resolution']['copying_list_into_fieldset'](
      instruction['line'] + context['indexing']
    )

    snippet = context['reporter'].report(context, instruction)

    selection = [
      [instruction['line'], 0],
      [instruction['line'], instruction['length']]
    ]

    return ParseError(message, snippet, selection)

  @staticmethod
  def copying_list_into_section(context, instruction):
    message = context['messages']['resolution']['copying_list_into_section'](
      instruction['line'] + context['indexing']
    )

    snippet = context['reporter'].report(context, instruction)

    selection = [
      [instruction['line'], 0],
      [instruction['line'], instruction['length']]
    ]

    return ParseError(message, snippet, selection)

  @staticmethod
  def copying_section_into_fieldset(context, instruction):
    message = context['messages']['resolution']['copying_section_into_fieldset'](
      instruction['line'] + context['indexing']
    )

    snippet = context['reporter'].report(context, instruction)

    selection = [
      [instruction['line'], 0],
      [instruction['line'], instruction['length']]
    ]

    return ParseError(message, snippet, selection)

  @staticmethod
  def copying_section_into_empty(context, instruction):
    message = context['messages']['resolution']['copying_section_into_empty'](
      instruction['line'] + context['indexing']
    )

    snippet = context['reporter'].report(context, instruction)

    selection = [
      [instruction['line'], 0],
      [instruction['line'], instruction['length']]
    ]

    return ParseError(message, snippet, selection)

  @staticmethod
  def copying_section_into_field(context, instruction):
    message = context['messages']['resolution']['copying_section_into_field'](
      instruction['line'] + context['indexing']
    )

    snippet = context['reporter'].report(context, instruction)

    selection = [
      [instruction['line'], 0],
      [instruction['line'], instruction['length']]
    ]

    return ParseError(message, snippet, selection)

  @staticmethod
  def copying_section_into_list(context, instruction):
    message = context['messages']['resolution']['copying_section_into_list'](
      instruction['line'] + context['indexing']
    )

    snippet = context['reporter'].report(context, instruction)

    selection = [
      [instruction['line'], 0],
      [instruction['line'], instruction['length']]
    ]

    return ParseError(message, snippet, selection)

  @staticmethod
  def cyclic_dependency(context, instruction, instruction_chain):
    first_occurrence = instruction_chain.index(instruction)
    feedback_chain = instruction_chain[first_occurrence:]

    if 'template' in feedback_chain[-1]:
      copy_instruction = feedback_chain[-1]
    elif 'template' in feedback_chain[0]:
      copy_instruction = feedback_chain[0]

    message = context['messages']['resolution']['cyclic_dependency'](
      copy_instruction['line'] + context['indexing'],
      copy_instruction['template']
    )

    snippet = context['reporter'].report(
      context,
      copy_instruction,
      [i for i in feedback_chain if i != copy_instruction]
    )

    selection = [
      [copy_instruction['line'], copy_instruction['ranges']['template'][0]],
      [copy_instruction['line'], copy_instruction['ranges']['template'][1]]
    ]

    return ParseError(message, snippet, selection)

  @staticmethod
  def multiple_templates_found(context, instruction, templates):
    message = context['messages']['resolution']['multiple_templates_found'](
      instruction['line'] + context['indexing'],
      instruction['template']
    )

    snippet = context['reporter'].report(context, [instruction, *templates])

    selection = [
      [instruction['line'], 0],
      [instruction['line'], instruction['length']]
    ]

    return ParseError(message, snippet, selection)

  @staticmethod
  def template_not_found(context, instruction):
    message = context['messages']['resolution']['template_not_found'](
      instruction['line'] + context['indexing'],
      instruction['template']
    )

    snippet = context['reporter'].report(context, instruction)

    selection = [
      [instruction['line'], 0],
      [instruction['line'], instruction['length']]
    ]

    return ParseError(message, snippet, selection)
